"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var esrgan_1 = require("../../../packages/shared/src/esrgan/esrgan");
var constants_generated_1 = require("./constants.generated");
var SCALE = 2;
var modelDefinition = (0, esrgan_1.getESRGANModelDefinition)({
    scale: SCALE,
    name: constants_generated_1.NAME,
    version: constants_generated_1.VERSION,
    path: 'models/model.json',
    meta: {
        C: 1,
        D: 2,
        G: 4,
        G0: 64,
        T: 10,
        architecture: "rdn",
        patchSize: 128,
        size: 'slim',
        artifactReducing: false,
        sharpening: false,
        dataset: 'div2k',
        modelFileName: 'rdn-C1-D2-G4-G064-T10-x2-patchsize128-compress100-sharpen0-datadiv2k-vary_cFalse_best-val_loss_epoch494',
    },
});
exports.default = modelDefinition;
